package zyh.robot.TextHTML;
import java.util.*;
import java.lang.*;
import java.io.*;
import java_cup.runtime.Symbol;
/**
 * JLex v1.2.5 generated lexical analyzer for the content filter of Text or HTML documents.
 */


public class Yylex {
	private final int YY_BUFFER_SIZE = 512;
	private final int YY_F = -1;
	private final int YY_NO_STATE = -1;
	private final int YY_NOT_ACCEPT = 0;
	private final int YY_START = 1;
	private final int YY_END = 2;
	private final int YY_NO_ANCHOR = 4;
	private final int YY_BOL = 65536;
	private final int YY_EOF = 65537;

	public Symbol nextSymbol() throws java.io.IOException
	{
		try
		{
			return parse();
		}
		catch(java.lang.Error e)//Lexical Error
		{
			return new Symbol(sym.error);
		}
	}
	private java.io.BufferedReader yy_reader;
	private int yy_buffer_index;
	private int yy_buffer_read;
	private int yy_buffer_start;
	private int yy_buffer_end;
	private char yy_buffer[];
	private boolean yy_at_bol;
	private int yy_lexical_state;

	public Yylex (java.io.Reader reader) {
		this ();
		if (null == reader) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(reader);
	}

	public Yylex (java.io.InputStream instream) {
		this ();
		if (null == instream) {
			throw (new Error("Error: Bad input stream initializer."));
		}
		yy_reader = new java.io.BufferedReader(new java.io.InputStreamReader(instream));
	}

	private Yylex () {
		yy_buffer = new char[YY_BUFFER_SIZE];
		yy_buffer_read = 0;
		yy_buffer_index = 0;
		yy_buffer_start = 0;
		yy_buffer_end = 0;
		yy_at_bol = true;
		yy_lexical_state = YYINITIAL;
	}

	private boolean yy_eof_done = false;
	private final int YYINITIAL = 0;
	private final int yy_state_dtrans[] = {
		0
	};
	private void yybegin (int state) {
		yy_lexical_state = state;
	}
	private int yy_advance ()
		throws java.io.IOException {
		int next_read;
		int i;
		int j;

		if (yy_buffer_index < yy_buffer_read) {
			return yy_buffer[yy_buffer_index++];
		}

		if (0 != yy_buffer_start) {
			i = yy_buffer_start;
			j = 0;
			while (i < yy_buffer_read) {
				yy_buffer[j] = yy_buffer[i];
				++i;
				++j;
			}
			yy_buffer_end = yy_buffer_end - yy_buffer_start;
			yy_buffer_start = 0;
			yy_buffer_read = j;
			yy_buffer_index = j;
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}

		while (yy_buffer_index >= yy_buffer_read) {
			if (yy_buffer_index >= yy_buffer.length) {
				yy_buffer = yy_double(yy_buffer);
			}
			next_read = yy_reader.read(yy_buffer,
					yy_buffer_read,
					yy_buffer.length - yy_buffer_read);
			if (-1 == next_read) {
				return YY_EOF;
			}
			yy_buffer_read = yy_buffer_read + next_read;
		}
		return yy_buffer[yy_buffer_index++];
	}
	private void yy_move_end () {
		if (yy_buffer_end > yy_buffer_start &&
		    '\n' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
		if (yy_buffer_end > yy_buffer_start &&
		    '\r' == yy_buffer[yy_buffer_end-1])
			yy_buffer_end--;
	}
	private boolean yy_last_was_cr=false;
	private void yy_mark_start () {
		yy_buffer_start = yy_buffer_index;
	}
	private void yy_mark_end () {
		yy_buffer_end = yy_buffer_index;
	}
	private void yy_to_mark () {
		yy_buffer_index = yy_buffer_end;
		yy_at_bol = (yy_buffer_end > yy_buffer_start) &&
		            ('\r' == yy_buffer[yy_buffer_end-1] ||
		             '\n' == yy_buffer[yy_buffer_end-1] ||
		             2028/*LS*/ == yy_buffer[yy_buffer_end-1] ||
		             2029/*PS*/ == yy_buffer[yy_buffer_end-1]);
	}
	private java.lang.String yytext () {
		return (new java.lang.String(yy_buffer,
			yy_buffer_start,
			yy_buffer_end - yy_buffer_start));
	}
	private int yylength () {
		return yy_buffer_end - yy_buffer_start;
	}
	private char[] yy_double (char buf[]) {
		int i;
		char newbuf[];
		newbuf = new char[2*buf.length];
		for (i = 0; i < buf.length; ++i) {
			newbuf[i] = buf[i];
		}
		return newbuf;
	}
	private final int YY_E_INTERNAL = 0;
	private final int YY_E_MATCH = 1;
	private java.lang.String yy_error_string[] = {
		"Error: Internal error.\n",
		"Error: Unmatched input.\n"
	};
	private void yy_error (int code,boolean fatal) {
		java.lang.System.out.print(yy_error_string[code]);
		java.lang.System.out.flush();
		if (fatal) {
			throw new Error("Fatal Error.\n");
		}
	}
	private int[][] unpackFromString(int size1, int size2, String st) {
		int colonIndex = -1;
		String lengthString;
		int sequenceLength = 0;
		int sequenceInteger = 0;

		int commaIndex;
		String workString;

		int res[][] = new int[size1][size2];
		for (int i= 0; i < size1; i++) {
			for (int j= 0; j < size2; j++) {
				if (sequenceLength != 0) {
					res[i][j] = sequenceInteger;
					sequenceLength--;
					continue;
				}
				commaIndex = st.indexOf(',');
				workString = (commaIndex==-1) ? st :
					st.substring(0, commaIndex);
				st = st.substring(commaIndex+1);
				colonIndex = workString.indexOf(':');
				if (colonIndex == -1) {
					res[i][j]=Integer.parseInt(workString);
					continue;
				}
				lengthString =
					workString.substring(colonIndex+1);
				sequenceLength=Integer.parseInt(lengthString);
				workString=workString.substring(0,colonIndex);
				sequenceInteger=Integer.parseInt(workString);
				res[i][j] = sequenceInteger;
				sequenceLength--;
			}
		}
		return res;
	}
	private int yy_acpt[] = {
		/* 0 */ YY_NOT_ACCEPT,
		/* 1 */ YY_NO_ANCHOR,
		/* 2 */ YY_NO_ANCHOR,
		/* 3 */ YY_NO_ANCHOR,
		/* 4 */ YY_NO_ANCHOR,
		/* 5 */ YY_NO_ANCHOR,
		/* 6 */ YY_NO_ANCHOR,
		/* 7 */ YY_NO_ANCHOR,
		/* 8 */ YY_NO_ANCHOR,
		/* 9 */ YY_NO_ANCHOR,
		/* 10 */ YY_NO_ANCHOR,
		/* 11 */ YY_NO_ANCHOR,
		/* 12 */ YY_NO_ANCHOR,
		/* 13 */ YY_NO_ANCHOR,
		/* 14 */ YY_NO_ANCHOR,
		/* 15 */ YY_NO_ANCHOR,
		/* 16 */ YY_NO_ANCHOR,
		/* 17 */ YY_NO_ANCHOR,
		/* 18 */ YY_NO_ANCHOR,
		/* 19 */ YY_NO_ANCHOR,
		/* 20 */ YY_NOT_ACCEPT,
		/* 21 */ YY_NO_ANCHOR,
		/* 22 */ YY_NOT_ACCEPT,
		/* 23 */ YY_NO_ANCHOR,
		/* 24 */ YY_NOT_ACCEPT,
		/* 25 */ YY_NO_ANCHOR,
		/* 26 */ YY_NOT_ACCEPT,
		/* 27 */ YY_NO_ANCHOR,
		/* 28 */ YY_NOT_ACCEPT,
		/* 29 */ YY_NO_ANCHOR,
		/* 30 */ YY_NOT_ACCEPT,
		/* 31 */ YY_NO_ANCHOR,
		/* 32 */ YY_NO_ANCHOR,
		/* 33 */ YY_NO_ANCHOR,
		/* 34 */ YY_NO_ANCHOR,
		/* 35 */ YY_NO_ANCHOR,
		/* 36 */ YY_NO_ANCHOR,
		/* 37 */ YY_NO_ANCHOR,
		/* 38 */ YY_NO_ANCHOR,
		/* 39 */ YY_NO_ANCHOR,
		/* 40 */ YY_NO_ANCHOR,
		/* 41 */ YY_NO_ANCHOR,
		/* 42 */ YY_NO_ANCHOR,
		/* 43 */ YY_NO_ANCHOR,
		/* 44 */ YY_NO_ANCHOR,
		/* 45 */ YY_NO_ANCHOR,
		/* 46 */ YY_NO_ANCHOR,
		/* 47 */ YY_NO_ANCHOR,
		/* 48 */ YY_NO_ANCHOR,
		/* 49 */ YY_NO_ANCHOR,
		/* 50 */ YY_NO_ANCHOR,
		/* 51 */ YY_NO_ANCHOR,
		/* 52 */ YY_NO_ANCHOR,
		/* 53 */ YY_NO_ANCHOR,
		/* 54 */ YY_NO_ANCHOR,
		/* 55 */ YY_NO_ANCHOR,
		/* 56 */ YY_NO_ANCHOR,
		/* 57 */ YY_NO_ANCHOR,
		/* 58 */ YY_NO_ANCHOR,
		/* 59 */ YY_NO_ANCHOR,
		/* 60 */ YY_NO_ANCHOR,
		/* 61 */ YY_NO_ANCHOR,
		/* 62 */ YY_NO_ANCHOR,
		/* 63 */ YY_NO_ANCHOR,
		/* 64 */ YY_NO_ANCHOR,
		/* 65 */ YY_NO_ANCHOR,
		/* 66 */ YY_NO_ANCHOR,
		/* 67 */ YY_NO_ANCHOR,
		/* 68 */ YY_NO_ANCHOR,
		/* 69 */ YY_NO_ANCHOR
	};
	private int yy_cmap[] = unpackFromString(1,65538,
"28:8,1:3,28:2,1,28:18,1,23,29,28:4,30,28:5,26,28,5,28:12,4,2,3,28:2,13,12,1" +
"1,19,8,9,15,6,21,28,14,22,27,18,16,25,28,7,10,20,17,28:3,24,28:2,31,28:4,13" +
",12,11,19,8,9,15,6,21,28,14,22,27,18,16,25,28,7,10,20,17,28:3,24,28:65414,0" +
":2")[0];

	private int yy_rmap[] = unpackFromString(1,70,
"0,1:6,2,1,3:2,1,3:2,1,3,1,3:3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20," +
"21,22,23,24,25,26,27,28,29,3,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,4" +
"5,46,3,47,48,49,50,51")[0];

	private int yy_nxt[][] = unpackFromString(52,32,
"1,2,3,4,5,6,7,64:3,36,66,67,64:7,68,64:2,38,64:3,69,64,20,21,23,-1:38,64,39" +
",64:21,-1,64:2,-1:6,64:23,-1,64:2,-1,20:3,-1,20:24,8,20:2,-1,22:3,-1,22,21:" +
"23,22,46,21,-1,22:3,-1,22:25,11,22,-1:6,64:23,24,37,64,-1,24:3,-1,24:24,26," +
"24:2,-1:6,64:5,9,64:17,-1,64:2,-1:31,14,-1:6,64:20,10,64:2,-1,64:2,-1,28:3," +
"-1,28:25,30,28,-1:6,64:3,12,64:19,-1,64:2,-1:31,16,-1:6,64:7,13,64:15,-1,64" +
":2,-1:6,64:2,15,64:20,-1,64:2,-1:6,64:14,17,64:8,-1,64:2,-1:6,64:2,18,64:20" +
",-1,64:2,-1:6,64:13,19,64:9,-1,64:2,-1:6,64,25,64:12,40,64:8,-1,64:2,-1,28:" +
"3,-1,28,37:23,28,51,37,-1:6,64:13,44,64:6,27,64:2,-1,64:2,-1:6,64:2,29,64:2" +
"0,-1,64:2,-1:6,64,47,64:21,-1,64:2,-1:6,64:12,65,64:10,-1,64:2,-1:6,64:5,48" +
",64:17,-1,64:2,-1:6,64:14,49,64:8,-1,64:2,-1:6,64:10,50,64:12,-1,64:2,-1:6," +
"64:14,31,64:8,-1,64:2,-1:6,64:15,52,64:7,-1,64:2,-1:6,64:8,54,64:14,-1,64:2" +
",-1:6,64:16,32,64:6,-1,64:2,-1:6,64:5,55,64:17,-1,64:2,-1:6,64:23,-1,64,46," +
"-1:6,64:12,56,64:10,-1,64:2,-1:6,64:2,57,64:20,-1,64:2,-1:6,64:9,58,64:13,-" +
"1,64:2,-1:6,64:14,59,64:8,-1,64:2,-1:6,64:9,46,64:13,-1,64:2,-1:6,64:12,33," +
"64:10,-1,64:2,-1:6,64,60,64:21,-1,64:2,-1:6,64:18,61,64:4,-1,64:2,-1:6,64:1" +
"0,62,64:12,-1,64:2,-1:6,64:19,34,64:3,-1,64:2,-1:6,64:11,63,64:11,-1,64:2,-" +
"1:6,64:12,35,64:10,-1,64:2,-1:6,64:14,53,64:8,-1,64:2,-1:6,64:10,41,64:12,-" +
"1,64:2,-1:6,64:7,42,64:15,-1,64:2,-1:6,64:15,43,64:7,-1,64:2,-1:6,64:2,45,6" +
"4:20,-1,64:2");

	public Symbol parse ()
		throws java.io.IOException {
		int yy_lookahead;
		int yy_anchor = YY_NO_ANCHOR;
		int yy_state = yy_state_dtrans[yy_lexical_state];
		int yy_next_state = YY_NO_STATE;
		int yy_last_accept_state = YY_NO_STATE;
		boolean yy_initial = true;
		int yy_this_accept;

		yy_mark_start();
		yy_this_accept = yy_acpt[yy_state];
		if (YY_NOT_ACCEPT != yy_this_accept) {
			yy_last_accept_state = yy_state;
			yy_mark_end();
		}
		while (true) {
			if (yy_initial && yy_at_bol) yy_lookahead = YY_BOL;
			else yy_lookahead = yy_advance();
			yy_next_state = YY_F;
			yy_next_state = yy_nxt[yy_rmap[yy_state]][yy_cmap[yy_lookahead]];
			if (YY_EOF == yy_lookahead && true == yy_initial) {

					return (new Symbol(sym.EOF));
			}
			if (YY_F != yy_next_state) {
				yy_state = yy_next_state;
				yy_initial = false;
				yy_this_accept = yy_acpt[yy_state];
				if (YY_NOT_ACCEPT != yy_this_accept) {
					yy_last_accept_state = yy_state;
					yy_mark_end();
				}
			}
			else {
				if (YY_NO_STATE == yy_last_accept_state) {
					throw (new Error("Lexical Error: Unmatched Input."));
				}
				else {
					yy_anchor = yy_acpt[yy_last_accept_state];
					if (0 != (YY_END & yy_anchor)) {
						yy_move_end();
					}
					yy_to_mark();
					switch (yy_last_accept_state) {
					case 1:
						
					case -2:
						break;
					case 2:
						{}
					case -3:
						break;
					case 3:
						{ return new Symbol(sym.EQUAL);}
					case -4:
						break;
					case 4:
						{ return new Symbol(sym.GREATER_THAN);}
					case -5:
						break;
					case 5:
						{ return new Symbol(sym.LESS_THAN);}
					case -6:
						break;
					case 6:
						{ return new Symbol(sym.SLASH);}
					case -7:
						break;
					case 7:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -8:
						break;
					case 8:
						{ return new Symbol(sym.QQLINK,yytext().substring(1, yytext().length() - 1)); }
					case -9:
						break;
					case 9:
						{ return new Symbol(sym.SRC,yytext()); }
					case -10:
						break;
					case 10:
						{ return new Symbol(sym.COMMENTS,yytext()); }
					case -11:
						break;
					case 11:
						{ return new Symbol(sym.QQLINK,yytext().substring(1, yytext().length() - 1)); }
					case -12:
						break;
					case 12:
						{ return new Symbol(sym.HREF,yytext()); }
					case -13:
						break;
					case 13:
						{ return new Symbol(sym.META,yytext()); }
					case -14:
						break;
					case 14:
						{ return new Symbol(sym.QQLINK,yytext().substring(2, yytext().length() - 2));/*Try to parse some URL in Javascrpit code, for instance, document.write("<A HREF=\"http://www.somecomanpy.com/abc.html\">")*/ }
					case -15:
						break;
					case 15:
						{ return new Symbol(sym.TITLE,yytext()); }
					case -16:
						break;
					case 16:
						{ return new Symbol(sym.QQLINK,yytext().substring(2, yytext().length() - 2));/*Try to parse some URL in Javascrpit code, for instance, document.write("<A HREF=\"http://www.somecomanpy.com/abc.html\">")*/ }
					case -17:
						break;
					case 17:
						{ return new Symbol(sym.CONTENT,yytext()); }
					case -18:
						break;
					case 18:
						{ return new Symbol(sym.DOCTYPE,yytext()); }
					case -19:
						break;
					case 19:
						{ return new Symbol(sym.BACKGROUND,yytext()); }
					case -20:
						break;
					case 21:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -21:
						break;
					case 23:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -22:
						break;
					case 25:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -23:
						break;
					case 27:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -24:
						break;
					case 29:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -25:
						break;
					case 31:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -26:
						break;
					case 32:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -27:
						break;
					case 33:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -28:
						break;
					case 34:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -29:
						break;
					case 35:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -30:
						break;
					case 36:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -31:
						break;
					case 37:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -32:
						break;
					case 38:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -33:
						break;
					case 39:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -34:
						break;
					case 40:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -35:
						break;
					case 41:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -36:
						break;
					case 42:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -37:
						break;
					case 43:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -38:
						break;
					case 44:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -39:
						break;
					case 45:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -40:
						break;
					case 46:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -41:
						break;
					case 47:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -42:
						break;
					case 48:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -43:
						break;
					case 49:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -44:
						break;
					case 50:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -45:
						break;
					case 51:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -46:
						break;
					case 52:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -47:
						break;
					case 53:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -48:
						break;
					case 54:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -49:
						break;
					case 55:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -50:
						break;
					case 56:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -51:
						break;
					case 57:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -52:
						break;
					case 58:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -53:
						break;
					case 59:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -54:
						break;
					case 60:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -55:
						break;
					case 61:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -56:
						break;
					case 62:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -57:
						break;
					case 63:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -58:
						break;
					case 64:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -59:
						break;
					case 65:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -60:
						break;
					case 66:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -61:
						break;
					case 67:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -62:
						break;
					case 68:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -63:
						break;
					case 69:
						{ return new Symbol(sym.PHRASE,yytext()); }
					case -64:
						break;
					default:
						yy_error(YY_E_INTERNAL,false);
					case -1:
					}
					yy_initial = true;
					yy_state = yy_state_dtrans[yy_lexical_state];
					yy_next_state = YY_NO_STATE;
					yy_last_accept_state = YY_NO_STATE;
					yy_mark_start();
					yy_this_accept = yy_acpt[yy_state];
					if (YY_NOT_ACCEPT != yy_this_accept) {
						yy_last_accept_state = yy_state;
						yy_mark_end();
					}
				}
			}
		}
	}
}
